{
this program comes with absolutely no warranty.
use at your own risk.

written by Bas Steendijk
}

program eolconvert;

{$apptype console}

uses windows;

{$i-}

type
  dvar=array[0..0] of byte;
  pdvar=^dvar;

var
  ii:pdvar;
  a,b:integer;
  outbuf:array[0..1023] of byte;
  outofs:integer;
  f:file;
  size:integer;
  eoltype:integer;

procedure outflush;
begin
  blockwrite(f,outbuf[0],outofs);
  outofs := 0;
end;

procedure putbyte(b:byte);
begin
  if outofs >= sizeof(outbuf) then outflush;
  outbuf[outofs] := b;
  inc(outofs);
end;

procedure puteol;
begin
  case eoltype of
    1:putbyte(13);
    2:putbyte(10);
    3:begin putbyte(13);putbyte(10) end;
  end;
end;

begin
  if paramstr(3) = '' then begin
    writeln('program to convert text files EOL, from any to CR, LF, or CRLF');
    writeln('usage: eolconvert <infile> <outfile> <cr|lf|crlf>');
    halt;
  end;
  if (paramstr(3) = 'CR') or (paramstr(3) = 'cr') then eoltype := 1
  else if (paramstr(3) = 'LF') or (paramstr(3) = 'lf') then eoltype := 2
  else if (paramstr(3) = 'CRLF') or (paramstr(3) = 'crlf') then eoltype := 3
  else begin
    writeln('invalid EOL type for output file');
    halt;
  end;


  assignfile(f,paramstr(1));
  filemode := 0;
  reset(f,1);
  if ioresult <> 0 then begin
    writeln('error opening file for read');
    halt;
  end;
  size := filesize(f);
  getmem(ii,size+2);
  fillchar(ii[0],size+2,0);
  blockread(f,ii[0],size);
  closefile(f);

  assignfile(f,paramstr(2));
  filemode := 2;
  rewrite(f,1);
  if ioresult <> 0 then begin
    writeln('error opening file for write');
    halt;
  end;
  outofs := 0;
  a := 0;
  while ii[a] <> 0 do begin
    if (ii[a] = 13) then begin
      puteol;
      if ii[a+1] = 10 then inc(a);
    end else if (ii[a] = 10) then begin
      puteol;
    end else putbyte(ii[a]);
    inc(a);
  end;

  outflush;
  closefile(f);

end.
